/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.gtask.data;

import android.database.Cursor;
import android.text.TextUtils;
import android.util.Log;

import net.micode.notes.data.Notes;
import net.micode.notes.data.Notes.DataColumns;
import net.micode.notes.data.Notes.DataConstants;
import net.micode.notes.data.Notes.NoteColumns;
import net.micode.notes.gtask.exception.ActionFailureException;
import net.micode.notes.tool.GTaskStringUtils;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;


public class Task extends Node {
    private static final String TAG = Task.class.getSimpleName();

    private boolean mCompleted; // 声明一个布尔类型的变量，表示任务是否已完成
    private String mNotes; // 声明一个字符串类型的变量，表示任务的备注信息
    private JSONObject mMetaInfo; // 声明一个JSONObject类型的变量，表示任务的元信息
    private Task mPriorSibling; // 声明一个Task类型的变量，表示当前任务的上一个任务
    private TaskList mParent; // 声明一个TaskList类型的变量，表示当前任务所属的任务列表

    public Task() {
        super(); // 调用父类的无参构造函数
        mCompleted = false; // 初始化mCompleted为false
        mNotes = null; // 初始化mNotes为null
        mPriorSibling = null; // 初始化mPriorSibling为null
        mParent = null; // 初始化mParent为null
        mMetaInfo = null; // 初始化mMetaInfo为null
    }

    public JSONObject getCreateAction(int actionId) {
        JSONObject js = new JSONObject(); // 声明并初始化一个JSONObject对象

        try {
            // action_type
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_TYPE,
                    GTaskStringUtils.GTASK_JSON_ACTION_TYPE_CREATE); // 将指定的键值对放入JSONObject对象中

            // action_id
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_ID, actionId); // 将指定的键值对放入JSONObject对象中

            // index
            js.put(GTaskStringUtils.GTASK_JSON_INDEX, mParent.getChildTaskIndex(this)); // 将指定的键值对放入JSONObject对象中

            // entity_delta
            JSONObject entity = new JSONObject(); // 声明并初始化一个JSONObject对象
            entity.put(GTaskStringUtils.GTASK_JSON_NAME, getName()); // 将指定的键值对放入JSONObject对象中
            entity.put(GTaskStringUtils.GTASK_JSON_CREATOR_ID, "null"); // 将指定的键值对放入JSONObject对象中
            entity.put(GTaskStringUtils.GTASK_JSON_ENTITY_TYPE,
                    GTaskStringUtils.GTASK_JSON_TYPE_TASK); // 将指定的键值对放入JSONObject对象中
            if (getNotes() != null) { // 如果任务备注信息不为空
                entity.put(GTaskStringUtils.GTASK_JSON_NOTES, getNotes()); // 将指定的键值对放入JSONObject对象中
            }
            js.put(GTaskStringUtils.GTASK_JSON_ENTITY_DELTA, entity); // 将指定的键值对放入JSONObject对象中

            // parent_id
            js.put(GTaskStringUtils.GTASK_JSON_PARENT_ID, mParent.getGid()); // 将指定的键值对放入JSONObject对象中

            // dest_parent_type
            js.put(GTaskStringUtils.GTASK_JSON_DEST_PARENT_TYPE,
                    GTaskStringUtils.GTASK_JSON_TYPE_GROUP); // 将指定的键值对放入JSONObject对象中

            // list_id
            js.put(GTaskStringUtils.GTASK_JSON_LIST_ID, mParent.getGid()); // 将指定的键值对放入JSONObject对象中

            // prior_sibling_id
            if (mPriorSibling != null) { // 如果当前任务的上一个任务不为空
                js.put(GTaskStringUtils.GTASK_JSON_PRIOR_SIBLING_ID, mPriorSibling.getGid());
            }

        } catch (JSONException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
            throw new ActionFailureException("fail to generate task-create jsonobject");
        }

        return js;
    }
/*方法getUpdateAction(int actionId)返回一个JSONObject对象，其中包含了对该对象进行更新的操作信息。
    具体地，该方法首先创建一个空的JSONObject对象js。然后，将更新操作的类型action_type和更新操作的ID action_id分别存储到该对象中。
    接着，将该对象的ID、名称、是否删除等属性信息封装成一个JSONObject对象entity，并将其存储到js对象中。
    最后，如果有任何JSON异常，则会打印出错信息并抛出ActionFailureException异常。
    */
    public JSONObject getUpdateAction(int actionId) {
        JSONObject js = new JSONObject();

        try {
            // action_type
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_TYPE,
                    GTaskStringUtils.GTASK_JSON_ACTION_TYPE_UPDATE);

            // action_id
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_ID, actionId);

            // id
            js.put(GTaskStringUtils.GTASK_JSON_ID, getGid());

            // entity_delta
            JSONObject entity = new JSONObject();
            entity.put(GTaskStringUtils.GTASK_JSON_NAME, getName());
            if (getNotes() != null) {
                entity.put(GTaskStringUtils.GTASK_JSON_NOTES, getNotes());
            }
            entity.put(GTaskStringUtils.GTASK_JSON_DELETED, getDeleted());
            js.put(GTaskStringUtils.GTASK_JSON_ENTITY_DELTA, entity);

        } catch (JSONException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
            throw new ActionFailureException("fail to generate task-update jsonobject");
        }

        return js;
    }
/*方法setContentByRemoteJSON(JSONObject js)根据传入的JSONObject对象，将该类的对象的属性值进行更新。
    具体地，该方法首先检查传入的JSONObject对象是否为null，如果不是，则依次获取JSONObject对象中的id、last_modified、name、
    notes、deleted和completed属性，然后将它们分别存储到该类的对象的相应属性中。
    如果有任何JSON异常，则会打印出错信息并抛出ActionFailureException异常
    */
    public void setContentByRemoteJSON(JSONObject js) {
        if (js != null) {
            try {
                // id
                if (js.has(GTaskStringUtils.GTASK_JSON_ID)) {
                    setGid(js.getString(GTaskStringUtils.GTASK_JSON_ID));
                }

                // last_modified
                if (js.has(GTaskStringUtils.GTASK_JSON_LAST_MODIFIED)) {
                    setLastModified(js.getLong(GTaskStringUtils.GTASK_JSON_LAST_MODIFIED));
                }

                // name
                if (js.has(GTaskStringUtils.GTASK_JSON_NAME)) {
                    setName(js.getString(GTaskStringUtils.GTASK_JSON_NAME));
                }

                // notes
                if (js.has(GTaskStringUtils.GTASK_JSON_NOTES)) {
                    setNotes(js.getString(GTaskStringUtils.GTASK_JSON_NOTES));
                }

                // deleted
                if (js.has(GTaskStringUtils.GTASK_JSON_DELETED)) {
                    setDeleted(js.getBoolean(GTaskStringUtils.GTASK_JSON_DELETED));
                }

                // completed
                if (js.has(GTaskStringUtils.GTASK_JSON_COMPLETED)) {
                    setCompleted(js.getBoolean(GTaskStringUtils.GTASK_JSON_COMPLETED));
                }
            } catch (JSONException e) {
                Log.e(TAG, e.toString());
                e.printStackTrace();
                throw new ActionFailureException("fail to get task content from jsonobject");
            }
        }
    }

    public void setContentByLocalJSON(JSONObject js) {
        // 检查传入的 JSON 对象是否合法
        if (js == null || !js.has(GTaskStringUtils.META_HEAD_NOTE)
                || !js.has(GTaskStringUtils.META_HEAD_DATA)) {
            Log.w(TAG, "setContentByLocalJSON: nothing is avaiable");
        }

        try {
            // 获取元数据中的笔记和数据部分
            JSONObject note = js.getJSONObject(GTaskStringUtils.META_HEAD_NOTE);
            JSONArray dataArray = js.getJSONArray(GTaskStringUtils.META_HEAD_DATA);

            // 检查笔记类型是否为 Notes.TYPE_NOTE
            if (note.getInt(NoteColumns.TYPE) != Notes.TYPE_NOTE) {
                Log.e(TAG, "invalid type");
                return;
            }

            // 在数据部分中查找笔记内容
            for (int i = 0; i < dataArray.length(); i++) {
                JSONObject data = dataArray.getJSONObject(i);
                if (TextUtils.equals(data.getString(DataColumns.MIME_TYPE), DataConstants.NOTE)) {
                    setName(data.getString(DataColumns.CONTENT));
                    break;
                }
            }

        } catch (JSONException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
        }
    }

    public JSONObject getLocalJSONFromContent() {
        String name = getName();
        try {
            if (mMetaInfo == null) {
                // 新任务从网络创建
                if (name == null) {
                    Log.w(TAG, "the note seems to be an empty one");
                    return null;
                }

                // 创建 JSON 对象，并设置笔记和数据
                JSONObject js = new JSONObject();
                JSONObject note = new JSONObject();
                JSONArray dataArray = new JSONArray();
                JSONObject data = new JSONObject();
                data.put(DataColumns.CONTENT, name);
                dataArray.put(data);
                js.put(GTaskStringUtils.META_HEAD_DATA, dataArray);
                note.put(NoteColumns.TYPE, Notes.TYPE_NOTE);
                js.put(GTaskStringUtils.META_HEAD_NOTE, note);
                return js;
            } else {
                // 已同步的任务
                JSONObject note = mMetaInfo.getJSONObject(GTaskStringUtils.META_HEAD_NOTE);
                JSONArray dataArray = mMetaInfo.getJSONArray(GTaskStringUtils.META_HEAD_DATA);

                // 在数据部分中查找笔记内容，并设置新名称
                for (int i = 0; i < dataArray.length(); i++) {
                    JSONObject data = dataArray.getJSONObject(i);
                    if (TextUtils.equals(data.getString(DataColumns.MIME_TYPE), DataConstants.NOTE)) {
                        data.put(DataColumns.CONTENT, getName());
                        break;
                    }
                }

                // 设置笔记类型为 Notes.TYPE_NOTE
                note.put(NoteColumns.TYPE, Notes.TYPE_NOTE);
                return mMetaInfo;
            }
        } catch (JSONException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
            return null;
        }
    }
/*这个方法的作用是设置一些元数据信息。
    MetaData是一个对象，包含了需要设置的元数据信息。
    metaData.getNotes()方法返回一个字符串，表示需要设置的元数据信息。
    如果metaData对象不为null并且metaData.getNotes()不为null，则会将这个字符串转换为一个JSONObject对象，并将这个对象赋值给成员变量mMetaInfo。
    如果转换失败，则会打印一个警告日志，并将mMetaInfo设置为null
    */
    public void setMetaInfo(MetaData metaData) {
        if (metaData != null && metaData.getNotes() != null) {
            try {
                mMetaInfo = new JSONObject(metaData.getNotes());
            } catch (JSONException e) {
                Log.w(TAG, e.toString());
                mMetaInfo = null;
            }
        }
    }
/*这个方法的作用是获取一个同步操作的类型。
    Cursor是一个对象，代表了一个查询结果集。
    这个方法返回一个整数，表示需要执行的同步操作类型。
    首先，声明一个noteInfo对象，并将其初始化为null。
    如果mMetaInfo不为null并且包含了特定键名的键值对，则将noteInfo初始化为mMetaInfo中该键值对的JSONObject对象。
    */
    public int getSyncAction(Cursor c) {
        try {
            JSONObject noteInfo = null;
            if (mMetaInfo != null && mMetaInfo.has(GTaskStringUtils.META_HEAD_NOTE)) {
                noteInfo = mMetaInfo.getJSONObject(GTaskStringUtils.META_HEAD_NOTE);
            }

            if (noteInfo == null) {
                Log.w(TAG, "it seems that note meta has been deleted");
                return SYNC_ACTION_UPDATE_REMOTE;
            }

            if (!noteInfo.has(NoteColumns.ID)) {
                Log.w(TAG, "remote note id seems to be deleted");
                return SYNC_ACTION_UPDATE_LOCAL;
            }

            // validate the note id now
            if (c.getLong(SqlNote.ID_COLUMN) != noteInfo.getLong(NoteColumns.ID)) {
                Log.w(TAG, "note id doesn't match");
                return SYNC_ACTION_UPDATE_LOCAL;
            }

            if (c.getInt(SqlNote.LOCAL_MODIFIED_COLUMN) == 0) {
                // there is no local update
                if (c.getLong(SqlNote.SYNC_ID_COLUMN) == getLastModified()) {
                    // no update both side
                    return SYNC_ACTION_NONE;
                } else {
                    // apply remote to local
                    return SYNC_ACTION_UPDATE_LOCAL;
                }
            } else {
                // validate gtask id
                if (!c.getString(SqlNote.GTASK_ID_COLUMN).equals(getGid())) {
                    Log.e(TAG, "gtask id doesn't match");
                    return SYNC_ACTION_ERROR;
                }
                if (c.getLong(SqlNote.SYNC_ID_COLUMN) == getLastModified()) {
                    // local modification only
                    return SYNC_ACTION_UPDATE_REMOTE;
                } else {
                    return SYNC_ACTION_UPDATE_CONFLICT;
                }
            }
        } catch (Exception e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
        }

        return SYNC_ACTION_ERROR;
    }
/*isWorthSaving(): 判断Task对象是否值得被保存。如果mMetaInfo不为null，或者name和notes属性都不为空，则返回true，否则返回false。
    setCompleted(boolean completed): 设置Task对象的completed属性为传入的参数。
    setNotes(String notes): 设置Task对象的notes属性为传入的参数。
    setPriorSibling(Task priorSibling): 设置Task对象的priorSibling属性为传入的参数。
    setParent(TaskList parent): 设置Task对象的parent属性为传入的参数。
    getCompleted(): 获取Task对象的completed属性。
    getNotes(): 获取Task对象的notes属性。
    getPriorSibling(): 获取Task对象的priorSibling属性。
    getParent(): 获取Task对象的parent属性。
    */
    public boolean isWorthSaving() {
        return mMetaInfo != null || (getName() != null && getName().trim().length() > 0)
                || (getNotes() != null && getNotes().trim().length() > 0);
    }

    public void setCompleted(boolean completed) {
        this.mCompleted = completed;
    }

    public void setNotes(String notes) {
        this.mNotes = notes;
    }

    public void setPriorSibling(Task priorSibling) {
        this.mPriorSibling = priorSibling;
    }

    public void setParent(TaskList parent) {
        this.mParent = parent;
    }

    public boolean getCompleted() {
        return this.mCompleted;
    }

    public String getNotes() {
        return this.mNotes;
    }

    public Task getPriorSibling() {
        return this.mPriorSibling;
    }

    public TaskList getParent() {
        return this.mParent;
    }

}
